package sun.rmi.registry;

import java.rmi.NotBoundException;
import java.rmi.UnmarshalException;
import java.rmi.AccessException;
import java.io.ObjectOutput;
import java.rmi.UnexpectedException;
import java.rmi.AlreadyBoundException;
import java.rmi.RemoteException;
import java.io.IOException;
import java.rmi.MarshalException;
import sun.rmi.transport.StreamRemoteCall;
import java.rmi.server.RemoteRef;
import java.rmi.server.Operation;
import java.rmi.Remote;
import java.rmi.registry.Registry;
import java.rmi.server.RemoteStub;

public final class RegistryImpl_Stub extends RemoteStub implements Registry, Remote
{
    private static final Operation[] operations;
    private static final long interfaceHash = 4905912898345647071L;
    
    public RegistryImpl_Stub() {
    }
    
    public RegistryImpl_Stub(RemoteRef ref) {
        super(ref);
    }
    
    @Override
    public void bind(String s, Remote remote) throws AccessException, AlreadyBoundException, RemoteException {
        try {
            StreamRemoteCall streamRemoteCall = (StreamRemoteCall)this.ref.newCall(this, RegistryImpl_Stub.operations, 0, 4905912898345647071L);
            try {
                ObjectOutput outputStream = streamRemoteCall.getOutputStream();
                outputStream.writeObject(s);
                outputStream.writeObject(remote);
            }
            catch (IOException ex) {
                throw new MarshalException("error marshalling arguments", ex);
            }
            this.ref.invoke(streamRemoteCall);
            this.ref.done(streamRemoteCall);
        }
        catch (RuntimeException ex2) {
            throw ex2;
        }
        catch (RemoteException ex3) {
            throw ex3;
        }
        catch (AlreadyBoundException ex4) {
            throw ex4;
        }
        catch (Exception ex5) {
            throw new UnexpectedException("undeclared checked exception", ex5);
        }
    }
    
    @Override
    public String[] list() throws AccessException, RemoteException {
        try {
            StreamRemoteCall streamRemoteCall = (StreamRemoteCall)this.ref.newCall(this, RegistryImpl_Stub.operations, 1, 4905912898345647071L);
            this.ref.invoke(streamRemoteCall);
            String[] array;
            try {
                array = (String[])(String[])streamRemoteCall.getInputStream().readObject();
            }
            catch (ClassCastException | IOException | ClassNotFoundException ex) {
                streamRemoteCall.discardPendingRefs();
                throw new UnmarshalException("error unmarshalling return", ex);
            }
            finally {
                this.ref.done(streamRemoteCall);
            }
            return array;
        }
        catch (RuntimeException ex2) {
            throw ex2;
        }
        catch (RemoteException ex3) {
            throw ex3;
        }
        catch (Exception ex4) {
            throw new UnexpectedException("undeclared checked exception", ex4);
        }
    }
    
    @Override
    public Remote lookup(String s) throws AccessException, NotBoundException, RemoteException {
        try {
            StreamRemoteCall streamRemoteCall = (StreamRemoteCall)this.ref.newCall(this, RegistryImpl_Stub.operations, 2, 4905912898345647071L);
            try {
                ObjectOutput outputStream = streamRemoteCall.getOutputStream();
                outputStream.writeObject(s);
            }
            catch (IOException ex) {
                throw new MarshalException("error marshalling arguments", ex);
            }
            this.ref.invoke(streamRemoteCall);
            ObjectOutput outputStream;
            try {
                outputStream = (Remote)streamRemoteCall.getInputStream().readObject();
            }
            catch (ClassCastException | IOException | ClassNotFoundException ex2) {
                streamRemoteCall.discardPendingRefs();
                throw new UnmarshalException("error unmarshalling return", ex2);
            }
            finally {
                this.ref.done(streamRemoteCall);
            }
            return outputStream;
        }
        catch (RuntimeException ex3) {
            throw ex3;
        }
        catch (RemoteException ex4) {
            throw ex4;
        }
        catch (NotBoundException ex5) {
            throw ex5;
        }
        catch (Exception ex6) {
            throw new UnexpectedException("undeclared checked exception", ex6);
        }
    }
    
    @Override
    public void rebind(String s, Remote remote) throws AccessException, RemoteException {
        try {
            StreamRemoteCall streamRemoteCall = (StreamRemoteCall)this.ref.newCall(this, RegistryImpl_Stub.operations, 3, 4905912898345647071L);
            try {
                ObjectOutput outputStream = streamRemoteCall.getOutputStream();
                outputStream.writeObject(s);
                outputStream.writeObject(remote);
            }
            catch (IOException ex) {
                throw new MarshalException("error marshalling arguments", ex);
            }
            this.ref.invoke(streamRemoteCall);
            this.ref.done(streamRemoteCall);
        }
        catch (RuntimeException ex2) {
            throw ex2;
        }
        catch (RemoteException ex3) {
            throw ex3;
        }
        catch (Exception ex4) {
            throw new UnexpectedException("undeclared checked exception", ex4);
        }
    }
    
    @Override
    public void unbind(String s) throws AccessException, NotBoundException, RemoteException {
        try {
            StreamRemoteCall streamRemoteCall = (StreamRemoteCall)this.ref.newCall(this, RegistryImpl_Stub.operations, 4, 4905912898345647071L);
            try {
                streamRemoteCall.getOutputStream().writeObject(s);
            }
            catch (IOException ex) {
                throw new MarshalException("error marshalling arguments", ex);
            }
            this.ref.invoke(streamRemoteCall);
            this.ref.done(streamRemoteCall);
        }
        catch (RuntimeException ex2) {
            throw ex2;
        }
        catch (RemoteException ex3) {
            throw ex3;
        }
        catch (NotBoundException ex4) {
            throw ex4;
        }
        catch (Exception ex5) {
            throw new UnexpectedException("undeclared checked exception", ex5);
        }
    }
    
    static {
        operations = new Operation[] { new Operation("void bind(java.lang.String, java.rmi.Remote)"), new Operation("java.lang.String list()[]"), new Operation("java.rmi.Remote lookup(java.lang.String)"), new Operation("void rebind(java.lang.String, java.rmi.Remote)"), new Operation("void unbind(java.lang.String)") };
    }
}
